@import 'mixins/mixins';
@import 'common/var';

@include b(textarea) {
  position: relative;
  vertical-align: bottom;
  font-size: $--font-size-base;
  resize: none;
  background-color: inherit;

  @include e(inner) {
    display: block;
    resize: vertical;
    padding: 12px 30px 15px;
    line-height: 1.5;
    box-sizing: border-box;
    width: 100%;
    font-size: inherit;
    color: $--input-font-color;
    background-color: $--input-background-color;
    background-image: none;
    border: $--input-border;
    border-radius: $--input-border-radius;
    transition: $--border-transition-base;
    resize: none;

    &::placeholder {
      color: $--input-placeholder-color;
    }

    &:hover {
      border-color: $--input-hover-border;
    }

    &:focus {
      outline: none;
      border-color: $--input-focus-border;
    }

    &[border] {
      border-color: $--color-border;
      background-color: inherit;

      &:hover {
        border-color: $--color-border;
      }

      &:focus {
        outline: none;
        border-color: $--input-focus-border;
      }

      &[line] {
        border-radius: 0;
        border-left: none;
        border-right: none;
        border-top: none;
        padding: 22px 0 10px 0;
      }
    }
  }

  & .el-input__count {
    color: $--color-info;
    background: $--color-white;
    position: absolute;
    font-size: 12px;
    bottom: 5px;
    right: 10px;
  }

  @include when(disabled) {
    .el-textarea__inner {
      background-color: $--input-disabled-fill;
      border-color: $--input-disabled-border;
      color: $--input-disabled-color;
      cursor: not-allowed;
      resize: none;

      &::placeholder {
        color: $--input-disabled-placeholder-color;
      }

      &[border] {
        border-color: $--input-disabled-border;
        background-color: inherit;
        color: $--input-disabled-placeholder-color;
      }
    }
  }

  @include when(exceed) {
    .el-textarea__inner {
      border-color: $--color-danger;
    }

    .el-input__count {
      color: $--color-danger;
    }
  }
}

@include b(input) {
  position: relative;
  font-size: $--font-size-base;
  display: inline-block;
  width: 100%;
  @include scroll-bar;

  &.custom-line-select {
    display: flex;
    align-items: center;
    border-bottom: 2px solid #495271;
    padding-right: 40px;
    height: 72px;
    > div {
      font-size: 34px;
      text-transform: uppercase;
      flex: none;
      margin: 0 20px 0 0;
    }
    & .progress {
      flex: 1;
      font-size: 0px;
      margin: 0;
    }
  }

  & .el-input__clear {
    color: $--input-icon-color;
    font-size: $--input-font-size;
    cursor: pointer;
    transition: $--color-transition-base;

    &:hover {
      color: $--input-clear-hover-color;
    }
  }

  & .el-input__count {
    height: 100%;
    display: inline-flex;
    align-items: center;
    color: $--color-info;
    font-size: 12px;

    .el-input__count-inner {
      background: $--color-white;
      line-height: initial;
      display: inline-block;
      padding: 0 5px;
    }
  }

  @include e(inner) {
    -webkit-appearance: none;
    background-color: $--input-background-color;
    background-image: none;
    border-radius: $--input-border-radius;
    border: $--input-border;
    border-color: $--input-border-color;
    box-sizing: border-box;
    color: $--input-font-color;
    display: block;
    font-size: inherit;
    height: $--input-height;
    line-height: $--input-height;
    outline: none;
    padding: 12px 30px 15px 30px;
    transition: $--border-transition-base;
    width: 100%;
    text-overflow: ellipsis;

    &:-webkit-autofill {
      caret-color: $--input-font-color;
      -webkit-text-fill-color: $--input-font-color;
      box-shadow: inset 0 0 0 $--input-height $--input-background-color;
    }

    &::placeholder {
      color: $--input-placeholder-color;
    }

    &:hover {
      border-color: $--input-hover-border;
    }

    &:focus {
      outline: none;
      border-color: $--input-focus-border;
    }

    &[border] {
      border-color: $--color-border;
      background-color: inherit;
      &:hover {
        border-color: $--color-border;
      }

      &:focus {
        outline: none;
        border-color: $--input-focus-border;
      }

      &[line] {
        border-radius: 0;
        border-left: none;
        border-right: none;
        border-top: none;
        padding: 12px 0 0 0;
      }
    }
  }

  @include e(suffix) {
    position: absolute;
    height: 100%;
    right: 5px;
    top: 0;
    text-align: center;
    color: $--input-icon-color;
    transition: all 0.3s;
    pointer-events: none;
    display: flex;
    align-items: center;

    > * {
      flex: none;
    }

    svg {
      fill: #fff;
      width: 16px;
      height: 16px;
    }
  }

  @include e(suffix-inner) {
    pointer-events: all;
  }

  @include e(prefix) {
    position: absolute;
    height: 100%;
    left: 0px;
    width: 52px;
    top: -1px;
    text-align: right;
    color: $--color-primary;
    transition: all 0.3s;
    display: flex;
    align-items: center;
    justify-content: flex-end;
    font-size: 24px;
  }

  @include e(icon) {
    height: 100%;
    width: 25px;
    text-align: center;
    transition: all 0.3s;
    line-height: $--input-height;

    &:after {
      content: '';
      height: 100%;
      width: 0;
      display: inline-block;
      vertical-align: middle;
    }
  }

  @include e(validateIcon) {
    pointer-events: none;
  }

  @include when(active) {
    .el-input__inner {
      outline: none;
      border-color: $--input-focus-border;
    }
  }

  @include when(disabled) {
    .el-input__inner {
      background-color: $--input-disabled-fill;
      border-color: $--input-disabled-border;
      color: $--input-disabled-color;
      cursor: not-allowed;

      &[border] {
        border-color: $--color-border;
        background-color: inherit;
        color: $--input-disabled-placeholder-color;
      }

      &::placeholder {
        color: $--input-disabled-placeholder-color;
      }
    }

    .el-input__icon {
      cursor: not-allowed;
    }
  }

  @include when(exceed) {
    .el-input__inner {
      border-color: $--color-danger;
    }

    .el-input__suffix {
      .el-input__count {
        color: $--color-danger;
      }
    }
  }

  @include m(suffix) {
    .el-input__inner {
      padding-right: 52px;

      &[border] {
        &[line] {
          padding-right: 40px;
        }
      }
    }
  }

  @include m(prefix) {
    .el-input__inner {
      padding-left: 70px;

      &[border] {
        &[line] {
          padding-left: 30px;
          & + .el-input__prefix {
            justify-content: flex-start;
          }
        }
      }
    }
  }

  @include m(medium) {
    font-size: $--input-medium-font-size;

    @include e(inner) {
      height: $--input-medium-height;
      line-height: $--input-medium-height;
    }

    .el-input__icon {
      line-height: $--input-medium-height;
    }
  }

  @include m(small) {
    font-size: $--input-small-font-size;

    @include e(inner) {
      height: $--input-small-height;
      line-height: $--input-small-height;
    }

    .el-input__icon {
      line-height: $--input-small-height;
    }
  }

  @include m(mini) {
    font-size: $--input-mini-font-size;

    @include e(inner) {
      height: $--input-mini-height;
      line-height: $--input-mini-height;
    }

    .el-input__icon {
      line-height: $--input-mini-height;
    }
  }
}

@include b(input-group) {
  line-height: normal;
  display: inline-table;
  width: 100%;
  border-collapse: separate;
  border-spacing: 0;

  > .el-input__inner {
    vertical-align: middle;
    display: table-cell;
  }

  @include e((append, prepend)) {
    background-color: $--background-color-base;
    color: $--color-primary;
    vertical-align: middle;
    display: table-cell;
    position: relative;
    border: $--input-border;
    border-color: $--input-border-color;
    border-radius: $--input-border-radius;
    width: 1px;
    white-space: nowrap;

    &:focus {
      outline: none;
    }

    .el-select,
    .el-button {
      display: inline-block;
      margin: -10px -20px;
    }

    button.el-button,
    div.el-select .el-input__inner,
    div.el-select:hover .el-input__inner {
      border-color: transparent;
      background-color: transparent;
      color: inherit;
      border-top: 0;
      border-bottom: 0;
    }

    .el-button,
    .el-input {
      font-size: inherit;
    }
  }

  @include e(prepend) {
    border-right: 0;
    border-top-right-radius: 0;
    border-bottom-right-radius: 0;
    padding-left: 30px;
    &.border {
      background: 0;
      border: 0;
    }
  }

  @include e(append) {
    border-left: 0;
    border-top-left-radius: 0;
    border-bottom-left-radius: 0;
  }

  @include m(prepend) {
    .el-input__inner {
      border-top-left-radius: 0;
      border-bottom-left-radius: 0;
    }

    .el-select .el-input.is-focus .el-input__inner {
      border-color: transparent;
    }
  }

  @include m(append) {
    .el-input__inner {
      border-top-right-radius: 0;
      border-bottom-right-radius: 0;
    }

    .el-select .el-input.is-focus .el-input__inner {
      border-color: transparent;
    }
  }
}

/** disalbe default clear on IE */
.el-input__inner::-ms-clear {
  display: none;
  width: 0;
  height: 0;
}
